package jp.agentec.sinaburocast.action.admin.enquete;

import jp.agentec.sinaburocast.action.AbstractAction;
import jp.agentec.sinaburocast.common.util.SinaburoViewUtil;
import jp.agentec.sinaburocast.entity.AdminNotifyMail;
import jp.agentec.sinaburocast.entity.Enquete;
import jp.agentec.sinaburocast.entity.MemberNotifyMail;
import jp.agentec.sinaburocast.form.admin.enquete.EnqueteMailSettingForm;
import jp.agentec.sinaburocast.service.AdminNotifyMailService;
import jp.agentec.sinaburocast.service.EnqueteService;
import jp.agentec.sinaburocast.service.MemberNotifyMailService;
import jp.agentec.sinaburocast.service.QuestionService;

import org.apache.log4j.Logger;
import org.apache.struts.util.TokenProcessor;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

/**
 * アンケートメール設定
 *
 * @author choi-c
 *
 */
public class EnqueteMailSettingAction extends AbstractAction {
	
	private final Logger logger = Logger.getLogger(getClass());

	@ActionForm
	public EnqueteMailSettingForm enqueteMailSettingForm;
	
	public EnqueteService enqueteService;
	
	public QuestionService questionService;
	
	public MemberNotifyMailService memberNotifyMailService;
	
	public AdminNotifyMailService adminNotifyMailService;
	
	/**
	 * 初期表示「アンケートメール設定」
	 */
	@Execute(validator = false)
	public String index() {
		Enquete enquete = enqueteService.findById(Integer.parseInt(enqueteMailSettingForm.eid));
		enqueteMailSettingForm.enqueteName = enquete.enqueteName;
		
		
		MemberNotifyMail memberNotifyMail = memberNotifyMailService.findByEnqueteId(Integer.parseInt(enqueteMailSettingForm.eid));
		if(memberNotifyMail != null){
			enqueteMailSettingForm.memberSubject           = memberNotifyMail.subject;
			enqueteMailSettingForm.memberMailBody          = memberNotifyMail.mailBody ;
			enqueteMailSettingForm.memberNotifyMailSendBcc = memberNotifyMail.notifyMailSendBcc;
			enqueteMailSettingForm.memberNotifyMailSendFlg = memberNotifyMail.notifyMailSendFlg.toString();
		}
		
		AdminNotifyMail  adminNotifyMail = adminNotifyMailService.findByEnqueteId(Integer.parseInt(enqueteMailSettingForm.eid));
		if(adminNotifyMail != null){
			enqueteMailSettingForm.adminMailBody          = adminNotifyMail.mailBody;
			enqueteMailSettingForm.adminNotifyMailSendCc  = adminNotifyMail.notifyMailSendCc;
			enqueteMailSettingForm.adminNotifyMailSendFlg = adminNotifyMail.notifyMailSendFlg.toString();
			enqueteMailSettingForm.adminNotifyMailSendTo  = adminNotifyMail.notifyMailSendTo;
			enqueteMailSettingForm.adminSubject = adminNotifyMail.subject;
		}
		
		return "/admin/enquete/enqueteMailSetting.html";
	}
	
	@Execute(validate = "validate", input="/admin/enquete/enqueteMailSetting.html")
	public String regist() {
		//トークンチェック
		if (!TokenProcessor.getInstance().isTokenValid(request, true)) {
			addError(SinaburoViewUtil.getMessage("errors.S999"));
			return "/error/doubleAction.html";
		}
		
		//メール設定
		adminNotifyMailService.registOrUpdate(enqueteMailSettingForm,getAdmin());
		
		return "/admin/enquete/enqueteMailSettingEnd.html";
	}
	
	@Execute(validate = "validate", input="/admin/enquete/enqueteMailSetting.html")
	public String confirm() {
		//トークンチェック
		
		TokenProcessor.getInstance().saveToken(request);
		
		return "/admin/enquete/enqueteMailSettingConfirm.html";
	}
	
		
}