package jp.agentec.sinaburocast.action.admin.setting;

import jp.agentec.sinaburocast.action.AbstractAction;
import jp.agentec.sinaburocast.common.SinaburoConstant;
import jp.agentec.sinaburocast.common.annotation.OperationHistoryAno;
import jp.agentec.sinaburocast.entity.AdminUser;
import jp.agentec.sinaburocast.form.admin.setting.AdminSearchForm;
import jp.agentec.sinaburocast.service.AdminUserService;

import org.apache.log4j.Logger;
import org.seasar.struts.annotation.ActionForm;
import org.seasar.struts.annotation.Execute;

/**
 * 管理者検索処理
 *
 * @author choi-c
 *
 */
public class AdminSearchAction extends AbstractAction {
	private final Logger logger = Logger.getLogger(getClass());

	@ActionForm
	public AdminSearchForm adminSearchForm;

	public AdminUserService adminUserService;
	
	/**
	 * 初期表示
	 */
	@Execute(validator = false )
	public String index() {
		adminSearchForm.adminUserList = adminUserService.findAllOrderByIdNotDel();
		
		adminSearchForm.adminUserList =  adminUserService.findAllOrderByIdPaging(null, adminSearchForm.pageNo, adminSearchForm);
		
		return "/admin/setting/adminSearch.html";
	}
	
	
	/**
	 * 初期表示「ページング」
	 */
    @Execute(validator = false,urlPattern = "search/{pageNo}")
	public String search() {
		adminSearchForm.adminUserList = adminUserService.findAllOrderByIdNotDel();
		
		adminSearchForm.adminUserList =  adminUserService.findAllOrderByIdPaging(null, adminSearchForm.pageNo, adminSearchForm);
		
		return "/admin/setting/adminSearch.html";
	}
    
    /**
	 * 管理者削除
	 */
    @Execute(validator = false)
    @OperationHistoryAno(operationTypeId=SinaburoConstant.OperationType.DELETE,target="管理者削除",detail="削除",screenId=SinaburoConstant.screenId.CAD0001)
	public String delete() {
    	AdminUser admin = adminUserService.findById(adminSearchForm.adminUserId);
    	if(admin.delFlg == null || admin.delFlg.equals(1)){
    		request.setAttribute(SinaburoConstant.notRegistOperationHistoryKey.notRegist, SinaburoConstant.notRegistOperationHistoryKey.notRegist);
    	} 
    	admin.delFlg=Integer.parseInt(SinaburoConstant.DelFlg.DEL);
		adminUserService.update(admin);
		return  search();
		//return "/admin/setting/adminSearch.html";
	}
    
    
    

}