package jp.agentec.sinaburocast.common.interceptor;

import java.io.Serializable;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.aopalliance.intercept.MethodInvocation;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.seasar.framework.aop.interceptors.AbstractInterceptor;
import org.seasar.framework.container.S2Container;

public abstract class SinaburoAbstractInterceptor extends AbstractInterceptor {
    private static final long serialVersionUID = -5850087766732170980L;

    private Log logger = LogFactory.getLog(getClass());
	protected S2Container container;

	public SinaburoAbstractInterceptor() {
		super();
	}

	/**
	 * S2Containerを返す。
	 * @return
	 */
	public S2Container getContainer() {
		return this.container;
	}

	/**
	 * S2Containerをセットする。
	 *
	 * @param container
	 */
	public void setContainer(S2Container container) {
		this.container = container.getRoot();
	}

	protected HttpServletResponse getResponse() {
		return (HttpServletResponse)container.getExternalContext().getResponse();
	}

	protected HttpServletRequest getRequest() {
		return (HttpServletRequest)container.getExternalContext().getRequest();
	}

	protected HttpSession getSession() {
		return (HttpSession) container.getExternalContext().getSession();
	}

	protected Map<String, Object> getSessionScope() {
		return (Map<String, Object>)container.getComponent("sessionScope");
	}

	protected Object getSessionAttribute(String key) {
		HttpSession session = getSession();
		return session.getAttribute(key);
	}

	protected void setSessionAttribute(String key, Serializable value) {
		HttpSession session = getSession();
		session.setAttribute(key,value);
	}

	protected String getClassName(MethodInvocation invocation) {
		return getTargetClass(invocation).getSimpleName();
	}


}